#ifndef MSP_IO_PIPE_H_
#define MSP_IO_PIPE_H_

#include "base.h"

namespace Msp {
namespace IO {

class Pipe: public Base
{
private:
	Handle handle[2];
#ifdef WIN32
	OVERLAPPED *overlapped;
	Handle event;
	unsigned buf_size;
	char *buffer;
	unsigned buf_avail;
	char *buf_next;
#endif

public:
	Pipe();
	~Pipe();

	void close();

	void set_block(bool);

protected:
	virtual unsigned do_write(const char *, unsigned);
	virtual unsigned do_read(char *, unsigned);

public:
	virtual Handle get_event_handle();
};

} // namespace IO
} // namespace Msp

#endif
